<?php

namespace Oro\ORM\Query\AST\Platform\Functions\Postgresql;

use Doctrine\ORM\Query\AST\Node;
use Doctrine\ORM\Query\SqlWalker;
use Oro\ORM\Query\AST\Functions\Cast as DqlFunction;
use Oro\ORM\Query\AST\Functions\SimpleFunction;
use Oro\ORM\Query\AST\Platform\Functions\PlatformFunctionNode;

class Cast extends PlatformFunctionNode
{
    /**
     * {@inheritdoc}
     */
    public function getSql(SqlWalker $sqlWalker)
    {
        /** @var Node $value */
        $value = $this->parameters[DqlFunction::PARAMETER_KEY];
        $type = $this->parameters[DqlFunction::TYPE_KEY];

        if (strtolower($type) == 'datetime') {
            $timestampFunction = new Timestamp(
                array(SimpleFunction::PARAMETER_KEY => $value)
            );

            return $timestampFunction->getSql($sqlWalker);
        }

        return 'CAST(' . $value->dispatch($sqlWalker) . ' AS ' . $type . ')';
    }
}
